E_MODEL_ICE_CUBE = smlua_model_util_get_id("ice_cube")
COL_ICE_CUBE = smlua_collision_util_get("ice_cube_collision")
E_MODEL_BRICK_PLATFORM = smlua_model_util_get_id("brick_platform")
COL_BRICK_PLATFORM = smlua_collision_util_get("brick_platform_collision")
E_MODEL_PINK_STAR = smlua_model_util_get_id("pink_star")

--Ice Cube

function bhv_ice_cube_init(obj)
    obj_set_model_extended(obj, E_MODEL_ICE_CUBE)
    obj.collisionData = COL_ICE_CUBE
end

hook_behavior(id_bhvArrowLift, OBJ_LIST_SURFACE, false, bhv_ice_cube_init, nil)

--Brick Platform

function bhv_brick_platform_init(obj)
    obj_set_model_extended(obj, E_MODEL_BRICK_PLATFORM)
    obj.collisionData = COL_BRICK_PLATFORM
end

hook_behavior(id_bhvSslMovingPyramidWall, OBJ_LIST_SURFACE, false, bhv_brick_platform_init, nil)

--Pink Star Secrets


function bhv_custom_secrets_init(o)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    obj_set_model_extended(o, E_MODEL_PINK_STAR)
end

function bhv_custom_secrets_loop(o)
    local secret = obj_get_nearest_object_with_behavior_id(o, id_bhvHiddenStarTrigger)
    o.oFaceAngleYaw = o.oFaceAngleYaw + 0x800
    if secret == nil or secret.oPosX ~= o.oPosX or secret.oPosY ~= o.oPosY or secret.oPosZ ~= o.oPosZ then
        obj_mark_for_deletion(o)
    end
end

id_bhvCustomSecrets = hook_behavior(bhvCustomSecrets, OBJ_LIST_LEVEL, false, bhv_custom_secrets_init, bhv_custom_secrets_loop)